
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE SAMPLE : menu : Ver 1.00
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
// 
//
//  v1.00 2001.11.09 MIO.H
//



#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <piece.h>
#include <launch.h>

#define TIMESTB 300
#define CHECK 0

unsigned char vbuff[128*88];

static unsigned char pos;
static unsigned char top;
static unsigned char blcnt;
static unsigned char blink;
static unsigned char dispstat;

static unsigned char draw;

#define DMAX 5


#if CHECK
#define icskip (*(unsigned char *)0x1f)
#endif



void disp_stat( void )
{
	PCETIME time;
	static unsigned char last_sec;

	pceTimeGet( &time );
	if ( last_sec != time.ss ) {
		last_sec = time.ss;
		pceFontSetPos( 128-5*20, 88-10 );
		pceFontPrintf( "%04d-%02d-%02d %02d:%02d:%02d",
			time.yy, time.mm, time.dd, time.hh, time.mi, time.ss );
		draw = 1;
	}
}


void disp( int f, int pos )
{
	pos -= top;
	if ( pos >= 0 && pos < DMAX ) {
		pceFontSetPos( 0, pos*10+20 );
		pceFontPrintf( "" );
		if ( f ) pceFontSetBkColor( 1 );
		pceFontPrintf( "%s", files[pos].caption );
		if ( f ) pceFontSetBkColor( 0 );
		draw = 1;
	}
}


void ref( int pos )
{
	static unsigned char lpos;
	FILES *pf = files + pos;

	disp( 0, lpos );
	if ( pos < filec ) {
		disp( 1, lpos = pos );

		pceFontSetPos( 0, 88-10*2 );
		pceFontPrintf( "%06x %06x", pf->adrs, pf->length );
	}
}


void up( void )
{
	if ( pos ) {
		pos--;
		ref( pos );
		blink = 1;
		blcnt = 0;
	}
}

void dn( void )
{
	if ( pos < filec-1 ) {
		pos++;
		ref( pos );
		blink = 1;
		blcnt = 0;
	}
}


void ts( void )
{
	PCETIME time;
	
	time.yy = 2001;
	time.mm = 8;
	time.dd = 5;
	time.hh = 11;
	time.mi = 14;
	time.ss = 0;
	pceTimeSet( &time );
}

void disp_frame( void )
{
	memset( vbuff, 0, 128*88 );
	memset( vbuff+128*9,  1, 128 );
	memset( vbuff+128*19, 1, 128 );

	{
		const SYSTEMINFO *sip = pceSystemGetInfo();
		pceFontSetPos( 0, 0 );
		pceFontSetBkColor( FC_SPRITE );
		pceFontPrintf( "PIECE - menu -\n"  );
		pceFontSetTxColor( 2 );
		pceFontPrintf( "BIOS ver%d.%02d ", sip->bios_ver>>8, sip->bios_ver&255 );
		pceFontPrintf( "20%02d.%02d.%02d\n", sip->bios_date>>9, (sip->bios_date>>5)&15, sip->bios_date&31 );
		pceFontSetTxColor( 3 );
		pceFontSetBkColor( 0 );
	}
}


void disp_files( void )
{
	getdir();

	if ( filec ) ref( pos = 0 );
	{
		int i;
		for ( i = 1; i < DMAX; i++ ) disp( 0, i );
	}
}


void pceAppInit( void )
{
	pceLCDDispStop();

	//pcePowerForceBatt(1);	// for test

	pceLCDSetBuffer( vbuff );
	pceAppSetProcPeriod( 80 );

	disp_frame();
	pceLCDTrans();

	pceLCDDispStart();

	pceCPUSetSpeed(CPU_SPEED_HALF);
	//pceCPUSetSpeed(3);
}


#if 0 // vȂȂ܂
void check_standby( void )
{
	PCEPWRSTAT ps;

	pcePowerGetStatus( &ps );

	if ( ps.status & 1 ) {
		if ( ++stbtime > TIMESTB*12 ) {
			go_standby();
			stbtime = 0;
		}
		return;
	}

	stbtime = 0;
}
#endif


#if 0
void wc( void )
{
	FILEACC facc;
	char *fname = "menu.c";
	int i;

	if ( pceFileOpen( &facc, fname, FOMD_WR ) ) return;

	for ( i = 0; i < 10; i++ ) {
		if ( !pceFileWriteSct( &facc, &i, i, 4 ) ) break;
	}

	pceFileClose( &facc );
}
#endif


void pceAppProc( int cnt )
{
	int a = pcePadGet();

#if CHECK
	if ( !icskip ) {
		if ( !dispstat ) {
			pceFontSetPos( 0, 22 );
			pceFontPrintf(
				" 肢 \n"
				"VXeCXg[\n"
				"ĉB\n"
				"i}jAQƁj"
				//"J[lVo[W"
				//"Abvf[gĂ"
				);
			pceLCDTrans();
			dispstat++;
		}
		else {
			if ( a == (PAD_A|PAD_B|PAD_LF) ) icskip++;;
		}
		return;
	}
#endif

	if ( dispstat < 2 ) {
		draw = 4;
		dispstat = 2;
		return;
	}

	if ( draw > 2 ) {
		disp_frame();
		disp_files();
	}

	if ( a & TRG_A  ) run( files + pos );
	if ( a & TRG_UP ) up();
	if ( a & TRG_DN ) dn();
	//if ( a & TRG_C ) wc();
	if ( (a & TRG_B) && (a & PAD_SELECT) ) {
		go_standby();
		draw = 4;
	}

	//if ( a ) stbtime = 0; else check_standby();

	disp_stat();

	if ( ++blcnt >= 4 ) {
		blcnt = 0;
		disp( blink, pos );
		blink ^= 1;
	}

	if ( draw ) {
		pceLCDTrans();
		draw = 0;
	}
}


void pceAppExit( void )
{
	pceCPUSetSpeed(CPU_SPEED_NORMAL);
}



